SystemOrganization addCategory: #'CS528prj-DependencyFinder'!
SystemOrganization addCategory: #'CS528prj-DependencyFinder-Test'!

Object subclass: #ClassInformation
	instanceVariableNames: 'packageName class dependencyDict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528prj-DependencyFinder'!

!ClassInformation commentStamp: '<historical>' prior: 0!
A ClassInformation class is a class that stores information about classes such as, a class name, its package name, and its dependency list

Instance Variables
packageName	a name of the package
class			a class object
dependencyDict	a dictionary containing dependencies.
!

!ClassInformation class methodsFor: 'initialize-release' stamp: 'RamonBespinyowong 4/13/2013 23:47'!
class: aClass packageName: aString
	^self new class: aClass packageName: aString! !

!ClassInformation methodsFor: 'accessing' stamp: 'RamonBespinyowong 4/14/2013 17:33'!
addDependencyTo: aClassName 
	dependencyDict
		at: aClassName  
		ifAbsent: [
			dependencyDict at: aClassName put: 0
			 ] .
		
	dependencyDict
		at: aClassName
		put: (dependencyDict at: aClassName)+1! !

!ClassInformation methodsFor: 'accessing' stamp: 'RamonBespinyowong 4/14/2013 17:33'!
addDependencyTo: aClassName total: aNumber
	dependencyDict
		at: aClassName  
		ifAbsent: [
			dependencyDict at: aClassName put: 0
			 ] .
		
	dependencyDict
		at: aClassName
		put: (dependencyDict at: aClassName)+aNumber! !

!ClassInformation methodsFor: 'initialize-release' stamp: 'RamonBespinyowong 4/13/2013 23:47'!
class: aClass packageName: aString
	class := aClass.
	packageName := aString! !

!ClassInformation methodsFor: 'initialize-release' stamp: 'RamonBespinyowong 4/14/2013 17:34'!
dependencyDict
	^dependencyDict! !

!ClassInformation methodsFor: 'initialize-release' stamp: 'RamonBespinyowong 4/14/2013 17:34'!
initialize
	dependencyDict := Dictionary new! !

!ClassInformation methodsFor: 'accessing' stamp: 'RamonBespinyowong 4/13/2013 23:47'!
packageName
	^packageName! !

!ClassInformation methodsFor: 'accessing' stamp: 'RamonBespinyowong 4/13/2013 23:48'!
storedClass
	^ class! !

!ClassInformation methodsFor: 'accessing' stamp: 'RamonBespinyowong 4/15/2013 02:07'!
storedClassName
	^self storedClass asString! !

Object subclass: #ClassReferenceBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528prj-DependencyFinder'!

!ClassReferenceBrowser commentStamp: '<historical>' prior: 0!
A ClassReferenceBrowser is a class for parsing string from 'allCallsOn' message to a dictionary of class reference

usage:
ClassReferenceBrowser findReferenceDictionaryOf: "aClass"

!

!ClassReferenceBrowser class methodsFor: 'accessing' stamp: 'RamonBespinyowong 4/14/2013 17:04'!
findReferenceDictionaryOf: aClass
	| referenceCollection refClassName returnDictionary|
	returnDictionary := Dictionary new.
	
	referenceCollection := aClass allCallsOn.
	
	referenceCollection do: [:each |
		refClassName := self getClassNameFrom: (each fullName asString).
		returnDictionary 
			at: refClassName
			ifAbsent: [returnDictionary at: refClassName put: 0].
		returnDictionary 
			at: refClassName 
			put: (returnDictionary at:refClassName) + 1
		].
	
	^returnDictionary ! !

!ClassReferenceBrowser class methodsFor: 'private' stamp: 'RamonBespinyowong 4/14/2013 16:59'!
getClassNameFrom: aString
	| classString reachBracket |
	classString := String new.
	reachBracket := false.
	
	aString do: [:each | 
						(each asString = '>' ) ifTrue: [reachBracket := true].
						reachBracket=false ifTrue: [classString := classString, each asString ]].
					
	^classString
	
	
	! !

Object subclass: #DependencyFinder
	instanceVariableNames: 'packageCollection classInfoCollection hasComputedDependencies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528prj-DependencyFinder'!

!DependencyFinder commentStamp: '<historical>' prior: 0!
A DependencyFinder class is a class for finding dependencies between classes and packages

usage:
refer to test

Instance Variables
!

!DependencyFinder methodsFor: 'initialize-release' stamp: 'RamonBespinyowong 4/14/2013 16:09'!
addPackageName: aPackageName
	packageCollection add: aPackageName! !

!DependencyFinder methodsFor: 'private' stamp: 'RamonBespinyowong 4/14/2013 16:15'!
addingClassesFrom: aPackageName
	| aClassArray |
	aClassArray := (PackageBrowser classArrayOf:  aPackageName).
	aClassArray do:[:aClass | 
		classInfoCollection add: (ClassInformation  class: aClass packageName: aPackageName)]! !

!DependencyFinder methodsFor: 'private' stamp: 'RamonBespinyowong 4/14/2013 00:06'!
addingClassesToClassCollection
	packageCollection 
		do:[:aPackagename |
			self addingClassesFrom: aPackagename
			]! !

!DependencyFinder methodsFor: 'initialize-release' stamp: 'RamonBespinyowong 4/14/2013 17:37'!
beginFindingDependency
	self addingClassesToClassCollection.
	self findingDependencies.
	hasComputedDependencies := true
	! !

!DependencyFinder methodsFor: 'private' stamp: 'RamonBespinyowong 4/14/2013 17:11'!
classInfoOf: aClassName 
	classInfoCollection do: [ :aClassInfo|
		(aClassInfo storedClass asString) = aClassName ifTrue: [^aClassInfo]].
	
	^ nil ! !

!DependencyFinder methodsFor: 'private' stamp: 'RamonBespinyowong 4/15/2013 02:15'!
findDependencyOf: aClassInfo
	|refDict anotherClassName numOccur anotherClassInfo|
	refDict := ClassReferenceBrowser findReferenceDictionaryOf: (aClassInfo storedClass).
	refDict associationsDo: [ :assoc | 
		anotherClassName := assoc key.
		numOccur := assoc value.
		anotherClassInfo := self classInfoOf: anotherClassName.
		anotherClassInfo isNil ifFalse: [
			anotherClassInfo addDependencyTo: aClassInfo storedClassName total: numOccur ] 
		]! !

!DependencyFinder methodsFor: 'private' stamp: 'RamonBespinyowong 4/14/2013 16:16'!
findingDependencies
	
	classInfoCollection do:[:aClassInformation |
		self findDependencyOf: aClassInformation]! !

!DependencyFinder methodsFor: 'accessing' stamp: 'RamonBespinyowong 4/15/2013 02:14'!
getNumDependencyFromPackage: aPackageName to: anotherPackageName 
	|dependencyDict anotherClassInfo count|
	hasComputedDependencies = false ifTrue: [ 
		self beginFindingDependency  ].
	
	count := 0.
	
	classInfoCollection do: [ :aClassInfo |
		aClassInfo packageName = aPackageName ifTrue:[
			dependencyDict := aClassInfo dependencyDict.
			dependencyDict associationsDo: [ :assoc | 
				anotherClassInfo:= self classInfoOf: (assoc key).
				anotherClassInfo = nil ifFalse: [ 
					anotherClassInfo packageName = anotherPackageName ifTrue:[
						count := count+ assoc value
					] 
				]
			]
		] 
	].

	^count! !

!DependencyFinder methodsFor: 'initialize-release' stamp: 'RamonBespinyowong 4/14/2013 17:37'!
initialize 
	packageCollection := OrderedCollection new.
	classInfoCollection := OrderedCollection new.
	hasComputedDependencies := false! !

Object subclass: #PackageBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528prj-DependencyFinder'!

!PackageBrowser commentStamp: '<historical>' prior: 0!
A PackageBrowser class is a class for browsing package in the MonticelloBrowser

Instance Variables
!

!PackageBrowser class methodsFor: 'accessing' stamp: 'RamonBespinyowong 4/14/2013 18:11'!
classArrayOf: aPackagename

	| index classArray | 
	
	index := self findPackageIndexOf: aPackagename.
	classArray := (MCWorkingCopy allManagers at:index) packageSet classes.
	
	^classArray! !

!PackageBrowser class methodsFor: 'private' stamp: 'RamonBespinyowong 4/14/2013 18:10'!
findPackageIndexOf: aPackageName
	|index managers|
	managers := MCWorkingCopy allManagers.
	
	index := 0.
	managers do: [:each |
		index := index+1.
		(each packageSet) packageName = aPackageName ifTrue: [^index]].
	
	^ self error: 'unable to find a package called ', aPackageName ! !

TestCase subclass: #DependencyFinderTest
	instanceVariableNames: 'df'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528prj-DependencyFinder-Test'!

!DependencyFinderTest methodsFor: 'as yet unclassified' stamp: 'RamonBespinyowong 4/15/2013 02:13'!
testDependencyFinder
	|count|
	df := DependencyFinder new.
	df addPackageName: 'MyPackageOne'.
	df addPackageName: 'MyPackageTwo'.
	count := df getNumDependencyFromPackage: 'MyPackageOne' to: 'MyPackageTwo'.
	self assert: 2 = count.
	count := df getNumDependencyFromPackage: 'MyPackageTwo' to: 'MyPackageOne'.
	self assert: 1 = count! !
